from typing import Generic, TypeVar

from rainbowadn.hashing.rainbow_factory import RainbowFactory

__all__ = ('Origin',)

OriginType = TypeVar('OriginType')


class Origin(Generic[OriginType]):
    def __init__(self, factory: RainbowFactory[OriginType]):
        self.factory = factory

    def resolve(self) -> OriginType:
        raise NotImplementedError
